/***************************************************************************
                          kplayerlogwindow.cpp
                          --------------------
    begin                : Fri May 9 2003
    copyright            : (C) 2003-2004 by kiriuja
    email                : kplayer-dev@en-directo.net
 ***************************************************************************/

/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <kdebug.h>
#include <klocale.h>

#include "kplayerlogwindow.h"
#include "kplayerlogwindow.moc"

#define DEBUG_KPLAYER_LOG

KPlayerLogWindow::KPlayerLogWindow (QWidget* parent, const char* name)
  : QDockWindow (parent, name)
{
  setWidget (new KPlayerLogWidget (this));
  setResizeEnabled (true);
  setCloseMode (QDockWindow::Always);
  setNewLine (true);
  setCaption (i18n("Messages"));
}

void KPlayerLogWindow::showEvent (QShowEvent* event)
{
#ifdef DEBUG_KPLAYER_LOG
  kdDebug() << "Log::showEvent\n";
#endif
  QDockWindow::showEvent (event);
  kPlayerLogWidget() -> scrollToBottom();
}

void KPlayerLogWindow::hideEvent (QHideEvent* event)
{
#ifdef DEBUG_KPLAYER_LOG
  kdDebug() << "Log::hideEvent\n";
#endif
  QDockWindow::hideEvent (event);
  if ( isHidden() ) // || ! event -> spontaneous() )
    emit windowHidden();
}

void KPlayerLogWindow::addLine (const QString& line)
{
  kPlayerLogWidget() -> append (line);
}

void KPlayerLogWindow::clear (void)
{
  kPlayerLogWidget() -> clear();
}

bool KPlayerLogWindow::isEmpty (void)
{
  return kPlayerLogWidget() -> text().isEmpty();
}

void KPlayerLogWindow::stopScrolling (void)
{
#ifdef DEBUG_KPLAYER_LOG
  kdDebug() << "Log::stopScrolling\n";
#endif
  kPlayerLogWidget() -> scrollBy (0, -1);
}

KPlayerLogWidget::KPlayerLogWidget (QWidget* parent, const char* name)
  : KTextEdit (parent, name)
{
  setTextFormat (Qt::PlainText);
  setReadOnly (true);
}

void KPlayerLogWidget::resizeEvent (QResizeEvent* event)
{
  bool at_bottom = contentsHeight() == contentsY() + visibleHeight();
//kdDebug() << "Log REvent " << event -> size(). width() << " " << event -> size(). height()
//  << " " << event -> oldSize(). width() << " " << event -> oldSize(). height()
//  << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
  KTextEdit::resizeEvent (event);
//kdDebug() << "           " << event -> size(). width() << " " << event -> size(). height()
//  << " " << event -> oldSize(). width() << " " << event -> oldSize(). height()
//  << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
  if ( at_bottom && contentsHeight() != contentsY() + visibleHeight() )
    scrollToBottom();
#ifdef DEBUG_KPLAYER_LOG
  kdDebug() << "Log::resizeEvent\n";
#endif
//kdDebug() << "           " << event -> size(). width() << " " << event -> size(). height()
//  << " " << event -> oldSize(). width() << " " << event -> oldSize(). height()
//  << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
}

/*void KPlayerLogWidget::setContentsPos (int x, int y)
{
//kdDebug() << "Log Scroll " << x << " " << y << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
  KTextEdit::setContentsPos (x, y);
//kdDebug() << "           " << x << " " << y << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
}

void KPlayerLogWidget::resizeContents (int w, int h)
{
//kdDebug() << "Log Resize " << w << " " << h << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
  KTextEdit::resizeContents (w, h);
//kdDebug() << "           " << w << " " << h << " " << contentsWidth() << " " << contentsHeight()
//  << " " << visibleWidth() << " " << visibleHeight() << " " << contentsX() << " " << contentsY() << "\n";
}*/
